import { type Functions } from 'firebase/functions';
import { Crypter } from '../crypter';
import { type FunctionType } from '../FunctionType';
import { type FirebaseRequestDescriptor, type FirebaseFunctionDescriptor, type FirebaseFunctions as FirebaseFunctionsType } from '../FirebaseFunctions';
import { type ValidReturnType } from '../ValidReturnType';
import { type ExpectResult } from './Expect';
export declare class FirebaseFunctions<FFunctions extends FirebaseFunctionsType> {
    private readonly functions;
    private readonly requestUrlComponent;
    private readonly cryptionKeys;
    private readonly callSecretKey;
    private readonly functionName?;
    constructor(functions: Functions, requestUrlComponent: string, cryptionKeys: Crypter.Keys, callSecretKey: string, functionName?: string | undefined);
    function<Key extends FirebaseFunctions.KeyIfRecord<FFunctions>>(key: Key): FirebaseFunctions<FirebaseFunctions.FFunctionIfRecord<FFunctions, Key>>;
    call(parameters: FirebaseFunctions.ParametersIfFunction<FFunctions>): Promise<ExpectResult<FirebaseFunctions.ReturnTypeIfFunction<FFunctions>>>;
    request(parameters: FirebaseFunctions.ParametersIfRequest<FFunctions>): Promise<ExpectResult<FirebaseFunctions.ReturnTypeIfRequest<FFunctions>>>;
}
declare namespace FirebaseFunctions {
    type KeyIfRecord<FFunctions extends FirebaseFunctionsType> = (FFunctions extends Record<string, FirebaseFunctionsType> ? (keyof FFunctions & string) : never);
    type FFunctionIfRecord<FFunctions extends FirebaseFunctionsType, Key extends keyof FFunctions> = FFunctions extends Record<string, FirebaseFunctionsType> ? FFunctions[Key] : never;
    type ParametersIfFunction<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseFunctionDescriptor<FunctionType<unknown, ValidReturnType, unknown>> ? FirebaseFunctionDescriptor.FlattenParameters<FFunctions> : never;
    type ReturnTypeIfFunction<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseFunctionDescriptor<FunctionType<unknown, ValidReturnType, unknown>> ? FirebaseFunctionDescriptor.ReturnType<FFunctions> : never;
    type ParametersIfRequest<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseRequestDescriptor<FunctionType<unknown, ValidReturnType, Record<string, string>>> ? FirebaseRequestDescriptor.FlattenParameters<FFunctions> : never;
    type ReturnTypeIfRequest<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseRequestDescriptor<FunctionType<unknown, ValidReturnType, Record<string, string>>> ? FirebaseRequestDescriptor.ReturnType<FFunctions> : never;
}
export {};
